/*
 * poppass.c -- Wrapper program for changing POP passwords over the
 *              web.
 * @(#)poppass.c v1.0 03 MAR 1997 Rob Thomas robt@cymru.com 
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>

#ifndef lint
char copyright[] = "@(#)Copyright (c) 1997 - Rob Thomas robt@cymru.com";
static char sccsid[] = "@(#)poppass.c v1.0 03 MAR 1997 Rob Thomas robt@cymru.com";
#endif

#ifndef PWDLOC
PWDLOC="/bin/passwd"
#endif

int
main(argc, argv)
	int argc;
	char **argv;
{
	pid_t	pid;
	int		pstatus,
			retry = 0;

	while (retry < 3) {
		retry++;

		if ((pid = fork()) < 0)
			fprintf(stderr, "%s: fork error\n", argv[0]);
		else if (pid == 0) {
			fprintf(stdout, "Changing your POP password...\n\n");
			if (execle(PWDLOC, "passwd", (char *) 0, NULL) < 0)
				fprintf(stderr, "%s: execle error\n", argv[0]);
		}
	
		if (wait(&pstatus) < 0)
			fprintf(stderr, "%s: waitpid error\n", argv[0]);
	
		if (pstatus == 0) {
			fprintf(stdout, "\nPlease wait while we make the final changes...\n");
			sleep(10);
			fprintf(stdout, "\n\007Your POP password has been changed!\n");
			sleep(3);
			exit(0);
		} else if ((pstatus != 0) && (retry < 3)) {
			fprintf(stdout,"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
			fprintf(stderr, "Oops!  Why not give it another shot?\n\n");
		}

	}
		
	fprintf(stderr, "Your POP password has NOT been changed.\n");
	fprintf(stderr, "Please contact your local administrator if you need assistance.\n");
	sleep(10);

	exit(1);
}
